"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var canvas_plugin_common_1 = require("./canvas-plugin.common");
var color_1 = require("tns-core-modules/color");
var image_source_1 = require("tns-core-modules/image-source");
var ColorHelper_1 = require("./ColorHelper");
__export(require("./canvas-plugin.common"));
function createSVGMatrix() {
    return new TNSDOMMatrix(com.github.triniwiz.canvas.CanvasView.createSVGMatrix());
}
exports.createSVGMatrix = createSVGMatrix;
var TNSCanvas = (function (_super) {
    __extends(TNSCanvas, _super);
    function TNSCanvas() {
        return _super.call(this) || this;
    }
    TNSCanvas.prototype.createNativeView = function () {
        this.canvas = new com.github.triniwiz.canvas.CanvasView(this._context, null);
        return this.canvas;
    };
    TNSCanvas.prototype.initNativeView = function () {
        _super.prototype.initNativeView.call(this);
    };
    TNSCanvas.prototype.disposeNativeView = function () {
        _super.prototype.disposeNativeView.call(this);
    };
    TNSCanvas.prototype.getContext = function (type) {
        if (type && type === '2d') {
            if (!this._2dContext) {
                this._2dContext = new TNSCanvasRenderingContext2D(this.canvas.getContext(type));
            }
        }
        return this._2dContext;
    };
    TNSCanvas.prototype.getBoundingClientRect = function () {
        var view = this;
        var nativeView = view.android;
        var width = this.getMeasuredWidth();
        var height = this.getMeasuredHeight();
        return {
            bottom: nativeView.getBottom(),
            height: height,
            left: nativeView.getLeft(),
            right: nativeView.getRight(),
            top: nativeView.getTop(),
            width: width,
            x: nativeView.getX(),
            y: nativeView.getY()
        };
    };
    return TNSCanvas;
}(canvas_plugin_common_1.TNSCanvasBase));
exports.TNSCanvas = TNSCanvas;
var ImageData = (function (_super) {
    __extends(ImageData, _super);
    function ImageData(nativeInstance) {
        var _this = _super.call(this, nativeInstance) || this;
        _this.data = Uint8ClampedArray.from(nativeInstance.getData());
        return _this;
    }
    ImageData.fromNative = function (nativeInstance) {
        return new ImageData(nativeInstance);
    };
    ImageData.from = function (instance) {
        return new ImageData(instance.nativeInstance);
    };
    return ImageData;
}(canvas_plugin_common_1.ImageDataBase));
exports.ImageData = ImageData;
var CanvasGradient = (function (_super) {
    __extends(CanvasGradient, _super);
    function CanvasGradient(nativeInstance) {
        var _this = _super.call(this) || this;
        _this.nativeInstance = nativeInstance;
        return _this;
    }
    CanvasGradient.prototype.addColorStop = function (offset, color) {
        this.nativeInstance.addColorStop(offset, new color_1.Color(color).android);
    };
    CanvasGradient.fromNative = function (nativeInstance) {
        return new CanvasGradient(nativeInstance);
    };
    return CanvasGradient;
}(canvas_plugin_common_1.CanvasGradientBase));
exports.CanvasGradient = CanvasGradient;
var TNSCanvasRenderingContext2D = (function (_super) {
    __extends(TNSCanvasRenderingContext2D, _super);
    function TNSCanvasRenderingContext2D(context) {
        var _this = _super.call(this) || this;
        _this.context = context;
        return _this;
    }
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowColor", {
        set: function (color) {
            this.context.setShadowColor(new color_1.Color(color).android);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "globalAlpha", {
        set: function (alpha) {
            this.context.setGlobalAlpha(alpha);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "imageSmoothingEnabled", {
        set: function (enabled) {
            this.context.setImageSmoothingEnabled(enabled);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "imageSmoothingQuality", {
        set: function (quality) {
            switch (quality) {
                case 'high':
                    this.context.setImageSmoothingQuality(com.github.triniwiz.canvas.CanvasRenderingContext2D.ImageSmoothingQuality.High);
                    break;
                case 'medium':
                    this.context.setImageSmoothingQuality(com.github.triniwiz.canvas.CanvasRenderingContext2D.ImageSmoothingQuality.Medium);
                    break;
                default:
                    this.context.setImageSmoothingQuality(com.github.triniwiz.canvas.CanvasRenderingContext2D.ImageSmoothingQuality.Low);
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineDashOffset", {
        set: function (offset) {
            this.context.setLineDashOffset(offset);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineJoin", {
        set: function (join) {
            switch (join) {
                case 'bevel':
                    this.context.setLineJoin(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineJoin.Bevel);
                    break;
                case 'round':
                    this.context.setLineJoin(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineJoin.Round);
                    break;
                default:
                    this.context.setLineJoin(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineJoin.Miter);
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineCap", {
        set: function (cap) {
            switch (cap) {
                case 'round':
                    this.context.setLineCap(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineCap.Round);
                    break;
                case 'square':
                    this.context.setLineCap(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineCap.Square);
                    break;
                default:
                    this.context.setLineCap(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineCap.Butt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "miterLimit", {
        set: function (limit) {
            this.context.setMiterLimit(limit);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowBlur", {
        set: function (blur) {
            this.context.setShadowBlur(blur);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowOffsetX", {
        set: function (x) {
            this.context.setShadowOffsetX(x);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowOffsetY", {
        set: function (y) {
            this.context.setShadowOffsetY(y);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "textAlign", {
        set: function (alignment) {
            switch (alignment) {
                case 'start':
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.Start);
                    break;
                case 'center':
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.Center);
                    break;
                case 'end':
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.End);
                    break;
                case 'right':
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.Right);
                    break;
                default:
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.Left);
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "globalCompositeOperation", {
        set: function (composite) {
            var operation;
            switch (composite.toLowerCase()) {
                case 'source-over':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SourceOver;
                    break;
                case 'source-in':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SourceIn;
                    break;
                case 'source-out':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SourceoOut;
                    break;
                case 'source-atop':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SourceAtop;
                    break;
                case 'destination-over':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.DestinationOver;
                    break;
                case 'destination-in':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.DestinationIn;
                    break;
                case 'destination-out':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.DestinationOut;
                    break;
                case 'destination-atop':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.DestinationAtop;
                    break;
                case 'lighter':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Lighter;
                    break;
                case 'copy':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Copy;
                    break;
                case 'xor':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Xor;
                    break;
                case 'multiply':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Multiply;
                    break;
                case 'screen':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Screen;
                    break;
                case 'overlay':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Overlay;
                    break;
                case 'darken':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Darken;
                    break;
                case 'lighten':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Lighten;
                    break;
                case 'color-dodge':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.ColorDodge;
                    break;
                case 'color-burn':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.ColorBurn;
                    break;
                case 'hard-light':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.HardLight;
                    break;
                case 'soft-light':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SoftLight;
                    break;
                case 'difference':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Difference;
                    break;
                case 'exclusion':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Exclusion;
                    break;
                case 'hue':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Hue;
                    break;
                case 'saturation':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Saturation;
                    break;
                case 'color':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Color;
                    break;
                case 'luminosity':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Luminosity;
                    break;
            }
            this.context.setGlobalCompositeOperation(operation);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "fillStyle", {
        set: function (color) {
            var nativeStyle;
            if (color instanceof CanvasGradient) {
                nativeStyle = color.nativeInstance;
            }
            else {
                if (color.startsWith('hsla')) {
                    color = ColorHelper_1.ColorHandler.HSLAToRGBA(color, false);
                }
                else if (color.startsWith('hsl')) {
                    color = ColorHelper_1.ColorHandler.HSLToRGB(color, false);
                }
                if (typeof color === 'string' && color.indexOf('Invalid input color') > -1) {
                    color = 'black';
                }
                nativeStyle = new com.github.triniwiz.canvas.CanvasColorStyle.Color(new color_1.Color(color).android);
            }
            this.context.setFillStyle(nativeStyle);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "strokeStyle", {
        set: function (color) {
            var nativeStyle;
            if (color instanceof CanvasGradient) {
                nativeStyle = color.nativeInstance;
            }
            else {
                if (color.startsWith('hsla')) {
                    color = ColorHelper_1.ColorHandler.HSLAToRGBA(color, false);
                }
                else if (color.startsWith('hsl')) {
                    color = ColorHelper_1.ColorHandler.HSLToRGB(color, false);
                }
                if (typeof color === 'string' && color.indexOf('Invalid input color') > -1) {
                    color = 'black';
                }
                nativeStyle = new com.github.triniwiz.canvas.CanvasColorStyle.Color(new color_1.Color(color).android);
            }
            this.context.setStrokeStyle(nativeStyle);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineWidth", {
        get: function () {
            return this.context.getLineWidth();
        },
        set: function (width) {
            this.context.setLineWidth(width);
        },
        enumerable: true,
        configurable: true
    });
    TNSCanvasRenderingContext2D.prototype.addHitRegion = function (region) {
    };
    TNSCanvasRenderingContext2D.prototype.arc = function (x, y, radius, startAngle, endAngle, anticlockwise) {
        this.context.arc(x, y, radius, startAngle, endAngle, anticlockwise);
    };
    TNSCanvasRenderingContext2D.prototype.arcTo = function (x1, y1, x2, y2, radius) {
        this.context.arcTo(x1, y1, x2, y2, radius);
    };
    TNSCanvasRenderingContext2D.prototype.beginPath = function () {
        this.context.beginPath();
    };
    TNSCanvasRenderingContext2D.prototype.bezierCurveTo = function (cp1x, cp1y, cp2x, cp2y, x, y) {
        this.context.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y);
    };
    TNSCanvasRenderingContext2D.prototype.clearHitRegions = function () {
    };
    TNSCanvasRenderingContext2D.prototype.clearRect = function (x, y, width, height) {
        this.context.clearRect(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.clip = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof args[0] === 'string') {
            this.context.clip(args[0]);
        }
        else if (args[0] instanceof TNSPath2D && typeof args[1] === 'string') {
            this.context.clip(args[0].native, args[1]);
        }
        else if (args[0] instanceof TNSPath2D) {
            this.context.clip(args[0].native);
        }
        else {
            this.context.clip();
        }
    };
    TNSCanvasRenderingContext2D.prototype.closePath = function () {
        this.context.closePath();
    };
    TNSCanvasRenderingContext2D.prototype.createImageData = function (width, height) {
        if (width instanceof ImageData) {
            return ImageData.from(width);
        }
        else {
            return ImageData.fromNative(this.context.createImageData(width, height));
        }
    };
    TNSCanvasRenderingContext2D.prototype.createLinearGradient = function (x0, y0, x1, y1) {
        return CanvasGradient.fromNative(this.context.createLinearGradient(x0, y0, x1, y1));
    };
    TNSCanvasRenderingContext2D.prototype.createPattern = function (image, repetition) {
    };
    TNSCanvasRenderingContext2D.prototype.createRadialGradient = function (x0, y0, r0, x1, y1, r1) {
        return CanvasGradient.fromNative(this.context.createRadialGradient(x0, y0, r0, x1, y1, r1));
    };
    TNSCanvasRenderingContext2D.prototype.drawFocusIfNeeded = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
    };
    TNSCanvasRenderingContext2D.prototype.drawImage = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var image = args[0];
        if (image instanceof image_source_1.ImageSource) {
            image = image.android;
        }
        if (args.length === 3) {
            this.context.drawImage(image, args[1], args[2]);
        }
        else if (args.length === 5) {
            this.context.drawImage(image, args[1], args[2], args[3], args[4]);
        }
        else if (args.length === 9) {
            this.context.drawImage(image, args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8]);
        }
    };
    TNSCanvasRenderingContext2D.prototype.ellipse = function (x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise) {
        this.context.ellipse(x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise);
    };
    TNSCanvasRenderingContext2D.prototype.fill = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof args[0] === 'string') {
            this.context.fill(args[0]);
        }
        else if (args[0] instanceof TNSPath2D && typeof args[1] === 'string') {
            this.context.fill(args[0].native, args[1]);
        }
        else if (args[0] instanceof TNSPath2D && typeof args[1] === 'string') {
            this.context.fill(args[0].native);
        }
        else {
            this.context.fill();
        }
    };
    TNSCanvasRenderingContext2D.prototype.fillRect = function (x, y, width, height) {
        this.context.fillRect(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.fillText = function (text, x, y, maxWidth) {
        this.context.fillText(text, x, y, maxWidth);
    };
    TNSCanvasRenderingContext2D.prototype.getImageData = function (sx, sy, sw, sh) {
        return ImageData.fromNative(this.context.getImageData(sx, sy, sw, sh));
    };
    TNSCanvasRenderingContext2D.prototype.getLineDash = function () {
        return this.context.getLineDash();
    };
    TNSCanvasRenderingContext2D.prototype.isPointInPath = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return false;
    };
    TNSCanvasRenderingContext2D.prototype.isPointInStroke = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return false;
    };
    TNSCanvasRenderingContext2D.prototype.lineTo = function (x, y) {
        this.context.lineTo(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.measureText = function (text) {
        return undefined;
    };
    TNSCanvasRenderingContext2D.prototype.moveTo = function (x, y) {
        this.context.moveTo(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.putImageData = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!args) {
            return;
        }
        var data = args[0];
        if (args.length === 1) {
            data.native.updateData(Array.from(data.data));
            this.context.putImageData(data.native);
        }
        else if (args.length === 3) {
            data.native.updateData(Array.from(data.data));
            this.context.putImageData(data.native, args[1], args[2]);
        }
        else if (args.length === 7) {
            data.native.updateData(Array.from(data.data));
            this.context.putImageData(data.native, args[1], args[2], args[3], args[4], args[5], args[6]);
        }
    };
    TNSCanvasRenderingContext2D.prototype.quadraticCurveTo = function (cpx, cpy, x, y) {
        this.context.quadraticCurveTo(cpx, cpy, x, y);
    };
    TNSCanvasRenderingContext2D.prototype.rect = function (x, y, width, height) {
        this.context.rect(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.removeHitRegion = function (id) {
    };
    TNSCanvasRenderingContext2D.prototype.resetTransform = function () {
        this.context.resetTransform();
    };
    TNSCanvasRenderingContext2D.prototype.restore = function () {
        this.context.restore();
    };
    TNSCanvasRenderingContext2D.prototype.rotate = function (angle) {
        this.context.rotate(angle);
    };
    TNSCanvasRenderingContext2D.prototype.save = function () {
        this.context.save();
    };
    TNSCanvasRenderingContext2D.prototype.scale = function (x, y) {
        this.context.scale(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.scrollPathIntoView = function (path) {
    };
    TNSCanvasRenderingContext2D.prototype.setLineDash = function (segments) {
        this.context.setLineDash(segments);
    };
    TNSCanvasRenderingContext2D.prototype.setTransform = function (a, b, c, d, e, f) {
        this.context.setTransform(a, b, c, d, e, f);
    };
    TNSCanvasRenderingContext2D.prototype.stroke = function (path) {
        if (path) {
            this.context.stroke(path.native);
        }
        else {
            this.context.stroke();
        }
    };
    TNSCanvasRenderingContext2D.prototype.strokeRect = function (x, y, width, height) {
        this.context.strokeRect(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.strokeText = function (text, x, y, maxWidth) {
        this.context.strokeText(text, x, y, maxWidth);
    };
    TNSCanvasRenderingContext2D.prototype.transform = function (a, b, c, d, e, f) {
        this.context.transform(a, b, c, d, e, f);
    };
    TNSCanvasRenderingContext2D.prototype.translate = function (x, y) {
        this.context.translate(x, y);
    };
    return TNSCanvasRenderingContext2D;
}(canvas_plugin_common_1.TNSCanvasRenderingContext2DBase));
exports.TNSCanvasRenderingContext2D = TNSCanvasRenderingContext2D;
var TextMetrics = (function (_super) {
    __extends(TextMetrics, _super);
    function TextMetrics(nativeInstance) {
        return _super.call(this, nativeInstance) || this;
    }
    Object.defineProperty(TextMetrics.prototype, "width", {
        get: function () {
            return this.nativeInstance.getWidth();
        },
        enumerable: true,
        configurable: true
    });
    return TextMetrics;
}(canvas_plugin_common_1.TextMetricsBase));
exports.TextMetrics = TextMetrics;
var TNSPath2D = (function (_super) {
    __extends(TNSPath2D, _super);
    function TNSPath2D(instance) {
        return _super.call(this, instance) || this;
    }
    TNSPath2D.prototype.addPath = function (path, transform) {
        if (transform) {
            this.nativeInstance.addPath(path.nativeInstance, transform.native);
        }
        else {
            this.nativeInstance.addPath(path.nativeInstance, null);
        }
    };
    TNSPath2D.prototype.arc = function (x, y, radius, startAngle, endAngle, anticlockwise) {
        if (anticlockwise === void 0) { anticlockwise = false; }
        this.nativeInstance.arc(x, y, radius, startAngle, endAngle, anticlockwise);
    };
    TNSPath2D.prototype.arcTo = function (x1, y1, x2, y2, radius) {
        this.nativeInstance.arcTo(x1, y1, x2, y2, radius);
    };
    TNSPath2D.prototype.bezierCurveTo = function (cp1x, cp1y, cp2x, cp2y, x, y) {
        this.nativeInstance.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y);
    };
    TNSPath2D.prototype.closePath = function () {
        this.nativeInstance.closePath();
    };
    TNSPath2D.prototype.ellipse = function (x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise) {
        if (anticlockwise === void 0) { anticlockwise = false; }
        this.nativeInstance.ellipse(x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise);
    };
    TNSPath2D.prototype.lineTo = function (x, y) {
        this.nativeInstance.lineTo(x, y);
    };
    TNSPath2D.prototype.moveTo = function (x, y) {
        this.nativeInstance.moveTo(x, y);
    };
    TNSPath2D.prototype.quadraticCurveTo = function (cpx, cpy, x, y) {
        this.nativeInstance.quadraticCurveTo(cpx, cpy, x, y);
    };
    TNSPath2D.prototype.rect = function (x, y, width, height) {
        this.nativeInstance.rect(x, y, width, height);
    };
    return TNSPath2D;
}(canvas_plugin_common_1.TNSPath2DBase));
exports.TNSPath2D = TNSPath2D;
var TNSDOMMatrix = (function (_super) {
    __extends(TNSDOMMatrix, _super);
    function TNSDOMMatrix(instance) {
        return _super.call(this, instance) || this;
    }
    Object.defineProperty(TNSDOMMatrix.prototype, "a", {
        get: function () {
            return this.nativeInstance.getA();
        },
        set: function (value) {
            this.nativeInstance.setA(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSDOMMatrix.prototype, "b", {
        get: function () {
            return this.nativeInstance.getB();
        },
        set: function (value) {
            this.nativeInstance.setB(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSDOMMatrix.prototype, "c", {
        get: function () {
            return this.nativeInstance.getC();
        },
        set: function (value) {
            this.nativeInstance.setC(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSDOMMatrix.prototype, "d", {
        get: function () {
            return this.nativeInstance.getD();
        },
        set: function (value) {
            this.nativeInstance.setD(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSDOMMatrix.prototype, "e", {
        get: function () {
            return this.nativeInstance.getE();
        },
        set: function (value) {
            this.nativeInstance.setE(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSDOMMatrix.prototype, "f", {
        get: function () {
            return this.nativeInstance.getF();
        },
        set: function (value) {
            this.nativeInstance.setF(value);
        },
        enumerable: true,
        configurable: true
    });
    return TNSDOMMatrix;
}(canvas_plugin_common_1.TNSDOMMatrixBase));
exports.TNSDOMMatrix = TNSDOMMatrix;
global.requestAnimationFrame = function (loop) {
    return com.github.triniwiz.canvas.AnimationFrame.requestAnimationFrame(new com.github.triniwiz.canvas.AnimationFrame.Callback({
        onFrame: function (called) {
            loop(called);
        }
    }));
};
global.cancelAnimationFrame = function (id) {
    com.github.triniwiz.canvas.AnimationFrame.cancelAnimationFrame(id);
};
//# sourceMappingURL=canvas-plugin.android.js.map